Heros roboFactor;
Voiture voitureA, voitureB, voitureC;
Boiteverte boiteA, boiteB;
PImage img;
PImage backG;

int xBlocage = -200; //Les entités se bloquent à une abscisse de -200, en attendant d'être rappellées.

void setup () {
  size (1000,600);
  img = loadImage("RobofactorProv.PNG");
  backG = loadImage ("city.jpg");
  roboFactor = new Heros(1, img);
  
  voitureA = new Voiture ((int)random(-1,3), xBlocage, generer(10, 31));
  voitureB = new Voiture ((int)random(-1,3), xBlocage, generer(10, 31));
  voitureC = new Voiture ((int)random(-1,3), xBlocage, generer(10, 31));
  
  boiteA = new Boiteverte((int)random(-1,3), xBlocage);
  boiteB = new Boiteverte((int)random(-1,3), xBlocage);
}

void draw () {
  //background (backG);
  background (80, 120, 200);
  image(backG, 0, 0, width, height);
  roboFactor.afficher();
  
  nouvelleEntite(); //On génère une nouvelle voiture ou une nouvelle boite aux lettres...
  
  roboFactor.deplacerYProgressif(); 
  
  gererBoite(boiteA);
  gererBoite(boiteB);
  
  gererVoiture(voitureA);
  gererVoiture(voitureB);
  gererVoiture(voitureC);
  
  gererCollision();
}

void keyPressed(){
  if(keyCode==UP){
    roboFactor.deplacerY(-1); //Robofactor va en haut si on appuie sur la flèche du haut
  }
  if(keyCode==DOWN){
    roboFactor.deplacerY(1); //Robofactor va en bas si on appuie sur la flèche du bas
  }
  if(key=='o'){
    voitureA = new Voiture ((int)random(-1,3), xBlocage, generer(10, 31));
    voitureB = new Voiture ((int)random(-1,3), xBlocage, generer(10, 31));
    voitureC = new Voiture ((int)random(-1,3), xBlocage, generer(10, 31));
  
    boiteA = new Boiteverte((int)random(-1,3), xBlocage);
    boiteB = new Boiteverte((int)random(-1,3), xBlocage);
    loop();
  }
}

void nouvelleEntite(){
  int generation;
  generation = (int)random(-1,151); //On génère un nombre aléatoirement entre 0 et 150 (entre -1 et 151 non compris).
  
  if(generation==0){ //Si on tombe sur 0, on "remet en jeu" une des trois voitures (il faut qu'elle soit bloquée en dehors de la fenêtre), à une rangée aléatoire    
    if(voitureA.getx()==xBlocage){
      voitureA = new Voiture ((int)random(-1,3), width+50, generer(10, 31));
    }
    
    else if(voitureB.getx()==xBlocage){
      voitureB = new Voiture ((int)random(-1,3), width+50, generer(10, 31));
    }
    
    else if(voitureC.getx()==xBlocage){
      voitureC = new Voiture ((int)random(-1,3), width+50, generer(10, 31));
    }
  }
  
  if(generation==1){ //Si on tombe sur 1, on "remet en jeu" une des deux boites (il faut qu'elle soit bloquée), à une rangée aléatoire
    generation = (int)random(-1,2);//On refait un tirage pour savoir quelle boite est "remise en jeu"
    if(generation==0 && boiteA.getx()==xBlocage){
      boiteA = new Boiteverte((int)random(-1,3), width+50);
    }
    
    if(generation==1 && boiteB.getx()==xBlocage){
      boiteB = new Boiteverte((int)random(-1,3), width+50);
    }
  }
}

void gererBoite(Boite boite){ //On affiche et on déplace la boite
  boite.afficher();
  boite.deplacerX();
}

void gererVoiture(Voiture voiture){ //On affiche et on déplace la voiture
  voiture.afficher();
  voiture.deplacerX(); 
}

void gererCollision(){
  roboFactor.collision(voitureA);
  roboFactor.collision(voitureB);
  roboFactor.collision(voitureC);
}

int generer(int debut, int fin){
  int aleatoire;
  aleatoire = (int)random(debut, fin+1);
  return aleatoire;
}

